uses
  TpDos,
  TpClone;

const
  ID    : array[1..5] of Byte = ($F7, $D0, $F7, $D2, $B9);
  fixID : array[1..6] of Byte = ($F7, $D0, $F7, $D2, $B9, $DC);

var
  gID : array[1..6] of Byte;
  FName : String;
  L : LongInt;
  CP : ClonePack;

  procedure Help;
  begin
    WriteLn('FIX for Borland Pascal 7.X programs on Pentium II.');
    WriteLn('Copyright (C) 1998 by G.A.V.');
    WriteLn;
    WriteLn('USAGE:');
    WriteLn;
    WriteLn(#9'P2FIX PROGRAM.EXE');
    WriteLn(#9'or');
    WriteLn(#9'P2FIX TURBO.TPL');
    Halt;
  end;

begin
  if ParamCount <> 1 then Help;
  FName := ParamStr(1);
  if not ExistFile(FName) then Help;

  FillChar(gID, 6, 0);
  OpenForCloning(FName, CP);
  L := FindDefaultsStart(CP, ID, SizeOf(ID), 0);
  LoadDefaults(CP, L, gID, 6);

  if L = 0 then
    begin
      WriteLn('Not need for fixing...');
    end
  else
    begin
      if gID[6] < $37 then WriteLn('Invalid BP7 program...');
      if gID[6] = $37 then WriteLn('Not fixed... Fixing!');
      if (gID[6] > $37) and (gID[6] < $DC) then WriteLn('Bad fix(',gID[6],')... Fixing!');
      if gID[6] >= $DC then WriteLn('Already fixed!');
      if (gID[6] >= $37) and (gID[6] < $DC) then StoreDefaults(CP, L, fixID, 6);
    end;

  CloseForCloning(CP);
end.